Bash 编程笔记

                     

贡献者: addis

  • 本词条处于草稿阶段。

1. 基础

关于引号

2. 判断

echo 123;
if [ $? -ne 0 ]; then # 判断 exit status
...
fi

# 判断路径是否存在(感叹号后面一定要有空格)
if ! [ -d "$repo" ]; then
    echo "directory not found!" 1>&2
fi

# 判断文件是否存在
if ! [ -f "$fname" ]; then
    echo "file not found!" 1>&2
fi

3. 循环

#!/bin/bash
for ((i = 1; i < 5; ++i))
# for i in {1,2,3,4} # 等效
do
	printf "\nfile${i}.txt\n"
done
如果在 printf 语句后面加上 && break,当前者失败时就会跳出循环。

   在当前目录中所有子目录循环

for d in */ ; do
    d=${d%/} # 删除目录名最后的斜杠
    echo "$d" # 打印所有子目录名
done

4. 数组

#!/bin/bash
arr=(1 3 hello 13)
for ((i=0;i<4;++i))
do
    printf "arr[${i}] = ${arr[i]}\n"
done

5. 输入

   例子

#!/bin/bash
# 确保文件最后有两个空格
# use `find . -type f -name "*.matt" -exec ./convert_matt.sh {} \;`
# to convert subfolder
file=${1}
printf "${file}... "
c2=$(tail -c 2 ${file})
if [ "${c2}" == "  " ]
then
	printf "already in new format\n"
else
	printf "  " >> ${file}
	printf "done\n"
fi

6. 特殊变量

7. 函数

   $0 是调用脚本的命令(也就是 argv[0])。$# 可以查看 args 的总个数


致读者: 小时百科一直以来坚持所有内容免费,这导致我们处于严重的亏损状态。 长此以往很可能会最终导致我们不得不选择大量广告以及内容付费等。 因此,我们请求广大读者热心打赏 ,使网站得以健康发展。 如果看到这条信息的每位读者能慷慨打赏 10 元,我们一个星期内就能脱离亏损, 并保证在接下来的一整年里向所有读者继续免费提供优质内容。 但遗憾的是只有不到 1% 的读者愿意捐款, 他们的付出帮助了 99% 的读者免费获取知识, 我们在此表示感谢。

                     

友情链接: 超理论坛 | ©小时科技 保留一切权利